#include <iostream>
#include <string.h>
#include "BoidTypes.h"

static int token_num = 0;

int getToken(FILE *fp, char *token)
{
	char seps[] = " ,\t\n{}()";
	int token_idx = 0;

	char curChar;
	bool flag = true;

	while(token_idx == 0 && flag) 
	{
		curChar = fgetc(fp);
		while(curChar != EOF && !strchr(seps, curChar)) 
		{
			token[token_idx] = curChar;
			token_idx++;
			curChar = fgetc(fp);
		}

		if (curChar == EOF)
				flag = false;

		if (strchr("{}()", curChar)) 
		{
			if (token_idx == 0) 
			{
					token[token_idx] = curChar;
					token_idx++;
			} else 
			{
					fseek(fp, -1, SEEK_CUR);
			}
		}
	}

	if (flag == false && token_idx == 0)
			return EOF;

	token[token_idx] = '\0';
	return token_idx;
}

int getToken(char *str, char *token)
{
	char seps[] = " ,\t\n";
    static char token_buf[MAX_TOKENS][TOKEN_LEN];
	//static int token_num = 0;
	static int token_idx = 0;
	char *p_token;

    if (token_num > 0) 
	{
		strcpy(token, token_buf[token_idx]);
		token_num--;
		token_idx++;
	} else 
	{
		if (p_token = strtok(str, seps))
		{
			strcpy(token, p_token);
		} else 
		{
			token[0] = '\0';
			return 0;
		}

		while(p_token = strtok(NULL, seps)) 
		{
			strcpy(token_buf[token_num], p_token);
			token_num++;
			if (token_num > MAX_TOKENS) 
			{
				std::cout << "getToken : token num overflow" << std::endl;
				_exit(0);
			}
		}
		token_idx = 0;
	}

	return token_num;
}

int getToken(char *str, char *token, char **buf)
{
	char seps[] = " ,\t\n";
	char *p_token;

	//p_token = strtok( str, seps );

#ifdef WIN32
	if (p_token = strtok_s(str, seps, buf))
	{
		strcpy(token, p_token);
	} else 
	{
		token[0] = '\0';
		return 0;
	}
#else
	if (p_token = strtok_r(str, seps, buf))
	{
		strcpy(token, p_token);
	} else 
	{
		token[0] = '\0';
		return 0;
	}
#endif

	return strlen(token);
}

int toupper(char *str)
{
	int len = strlen(str);

	for (int i=0; i<len; i++) {
		str[i] = ::toupper(str[i]);
	}

	return 0;
}

int tolower(char *str)
{
	int len = strlen(str);

	for (int i=0; i<len; i++) {
		str[i] = ::tolower(str[i]);
	}

	return 0;
}
